/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataPagerdutyLicenseConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license#allocations_available DataPagerdutyLicense#allocations_available}
    */
    readonly allocationsAvailable?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license#current_value DataPagerdutyLicense#current_value}
    */
    readonly currentValue?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license#description DataPagerdutyLicense#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license#html_url DataPagerdutyLicense#html_url}
    */
    readonly htmlUrl?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license#id DataPagerdutyLicense#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license#name DataPagerdutyLicense#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license#role_group DataPagerdutyLicense#role_group}
    */
    readonly roleGroup?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license#self DataPagerdutyLicense#self}
    */
    readonly selfAttribute?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license#summary DataPagerdutyLicense#summary}
    */
    readonly summary?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license#type DataPagerdutyLicense#type}
    */
    readonly type?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license#valid_roles DataPagerdutyLicense#valid_roles}
    */
    readonly validRoles?: string[];
}
/**
* Represents a {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license pagerduty_license}
*/
export declare class DataPagerdutyLicense extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "pagerduty_license";
    /**
    * Generates CDKTF code for importing a DataPagerdutyLicense resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataPagerdutyLicense to import
    * @param importFromId The id of the existing DataPagerdutyLicense that should be imported. Refer to the {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataPagerdutyLicense to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/license pagerduty_license} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataPagerdutyLicenseConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataPagerdutyLicenseConfig);
    private _allocationsAvailable?;
    get allocationsAvailable(): number;
    set allocationsAvailable(value: number);
    resetAllocationsAvailable(): void;
    get allocationsAvailableInput(): number | undefined;
    private _currentValue?;
    get currentValue(): number;
    set currentValue(value: number);
    resetCurrentValue(): void;
    get currentValueInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _htmlUrl?;
    get htmlUrl(): string;
    set htmlUrl(value: string);
    resetHtmlUrl(): void;
    get htmlUrlInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _roleGroup?;
    get roleGroup(): string;
    set roleGroup(value: string);
    resetRoleGroup(): void;
    get roleGroupInput(): string | undefined;
    private _self?;
    get selfAttribute(): string;
    set selfAttribute(value: string);
    resetSelfAttribute(): void;
    get selfAttributeInput(): string | undefined;
    private _summary?;
    get summary(): string;
    set summary(value: string);
    resetSummary(): void;
    get summaryInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _validRoles?;
    get validRoles(): string[];
    set validRoles(value: string[]);
    resetValidRoles(): void;
    get validRolesInput(): string[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
