/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataPagerdutyLicensesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#id DataPagerdutyLicenses#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * licenses block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#licenses DataPagerdutyLicenses#licenses}
    */
    readonly licenses?: DataPagerdutyLicensesLicenses[] | cdktf.IResolvable;
}
export interface DataPagerdutyLicensesLicenses {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#allocations_available DataPagerdutyLicenses#allocations_available}
    */
    readonly allocationsAvailable?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#current_value DataPagerdutyLicenses#current_value}
    */
    readonly currentValue?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#description DataPagerdutyLicenses#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#html_url DataPagerdutyLicenses#html_url}
    */
    readonly htmlUrl?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#id DataPagerdutyLicenses#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#name DataPagerdutyLicenses#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#role_group DataPagerdutyLicenses#role_group}
    */
    readonly roleGroup?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#self DataPagerdutyLicenses#self}
    */
    readonly selfAttribute?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#summary DataPagerdutyLicenses#summary}
    */
    readonly summary?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#type DataPagerdutyLicenses#type}
    */
    readonly type?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#valid_roles DataPagerdutyLicenses#valid_roles}
    */
    readonly validRoles?: string[];
}
export declare function dataPagerdutyLicensesLicensesToTerraform(struct?: DataPagerdutyLicensesLicenses | cdktf.IResolvable): any;
export declare function dataPagerdutyLicensesLicensesToHclTerraform(struct?: DataPagerdutyLicensesLicenses | cdktf.IResolvable): any;
export declare class DataPagerdutyLicensesLicensesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataPagerdutyLicensesLicenses | cdktf.IResolvable | undefined;
    set internalValue(value: DataPagerdutyLicensesLicenses | cdktf.IResolvable | undefined);
    private _allocationsAvailable?;
    get allocationsAvailable(): number;
    set allocationsAvailable(value: number);
    resetAllocationsAvailable(): void;
    get allocationsAvailableInput(): number | undefined;
    private _currentValue?;
    get currentValue(): number;
    set currentValue(value: number);
    resetCurrentValue(): void;
    get currentValueInput(): number | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _htmlUrl?;
    get htmlUrl(): string;
    set htmlUrl(value: string);
    resetHtmlUrl(): void;
    get htmlUrlInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _roleGroup?;
    get roleGroup(): string;
    set roleGroup(value: string);
    resetRoleGroup(): void;
    get roleGroupInput(): string | undefined;
    private _self?;
    get selfAttribute(): string;
    set selfAttribute(value: string);
    resetSelfAttribute(): void;
    get selfAttributeInput(): string | undefined;
    private _summary?;
    get summary(): string;
    set summary(value: string);
    resetSummary(): void;
    get summaryInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
    private _validRoles?;
    get validRoles(): string[];
    set validRoles(value: string[]);
    resetValidRoles(): void;
    get validRolesInput(): string[] | undefined;
}
export declare class DataPagerdutyLicensesLicensesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: DataPagerdutyLicensesLicenses[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataPagerdutyLicensesLicensesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses pagerduty_licenses}
*/
export declare class DataPagerdutyLicenses extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "pagerduty_licenses";
    /**
    * Generates CDKTF code for importing a DataPagerdutyLicenses resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataPagerdutyLicenses to import
    * @param importFromId The id of the existing DataPagerdutyLicenses that should be imported. Refer to the {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataPagerdutyLicenses to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/pagerduty/pagerduty/3.7.0/docs/data-sources/licenses pagerduty_licenses} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataPagerdutyLicensesConfig = {}
    */
    constructor(scope: Construct, id: string, config?: DataPagerdutyLicensesConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _licenses;
    get licenses(): DataPagerdutyLicensesLicensesList;
    putLicenses(value: DataPagerdutyLicensesLicenses[] | cdktf.IResolvable): void;
    resetLicenses(): void;
    get licensesInput(): cdktf.IResolvable | DataPagerdutyLicensesLicenses[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
